﻿using System;
using System.Threading;
using System.Threading.Tasks;

namespace TestProject;

/// <summary>
/// 프로그램
/// </summary>
class Program
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Private

    #region 작업 처리하기 - ProcessOperationAsync()

    /// <summary>
    /// 작업 처리하기
    /// </summary>
    /// <returns>작업 처리 결과 태스크</returns>
    private static Task<int> ProcessOperationAsync()
    {
        TaskCompletionSource<int> taskCompletionSource = new TaskCompletionSource<int>();

        Task.Run
        (
            async () =>
            {
                int mainThreadID = Thread.CurrentThread.ManagedThreadId;

                Console.WriteLine($"[{DateTime.Now.ToString("HH:mm:ss")}] 스레드 ID : {mainThreadID}, 비동기 작업 시작");

                await Task.Delay(3000);

                taskCompletionSource.SetResult(42);

                Console.WriteLine($"[{DateTime.Now.ToString("HH:mm:ss")}] 스레드 ID : {mainThreadID}, 비동기 작업 완료");
            }
        );

        return taskCompletionSource.Task;
    }

    #endregion

    #region 프로그램 시작하기 - Main()

    /// <summary>
    /// 프로그램 시작하기
    /// </summary>
    /// <returns>태스크</returns>
    private static async Task Main()
    {
        int mainThreadID = Thread.CurrentThread.ManagedThreadId;

        Console.WriteLine($"[{DateTime.Now.ToString("HH:mm:ss")}] 스레드 ID : {mainThreadID}, 프로그램 시작");

        Task<int> task = ProcessOperationAsync();

        for(int i = 0; i < 50; i++)
        {
            Console.WriteLine($"[{DateTime.Now.ToString("HH:mm:ss")}] 스레드 ID : {mainThreadID}, 항목 {i}");

            await Task.Delay(100);
        }

        int result = await task;

        Console.WriteLine($"[{DateTime.Now.ToString("HH:mm:ss")}] 스레드 ID : {mainThreadID}, 비동기 작업 결과 : {result}");

        Console.WriteLine($"[{DateTime.Now.ToString("HH:mm:ss")}] 스레드 ID : {mainThreadID}, 프로그램 종료");
    }

    #endregion
}